Robotsystem from Robot Group Leipzig: MultiLayerFFNN Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Alphabetical List
- Class Hierarchy
- Class Members

# MultiLayerFFNN Class Reference

`#include <multilayerffnn.h>`

Inheritance diagram for MultiLayerFFNN:

[legend]
Collaboration diagram for MultiLayerFFNN:

[legend]
List of all members.

## Detailed Description

multi layer neural network with configurable activation functions

Definition at line 22 of file multilayerffnn.h.

## Public Member Functions
| MultiLayerFFNN (double eps, const vector< Layer > &layers)
virtual | ~MultiLayerFFNN ()
virtual void | init (unsigned int inputDim, unsigned int outputDim)
| initialisation of the network with the given number of input and output units
virtual const matrix::Matrix | process (const matrix::Matrix &input) const
| passive processing of the input
virtual const matrix::Matrix | learn (const matrix::Matrix &input, const matrix::Matrix &nom_output, double learnRateFactor=1)
| performs learning and returns the network output before learning
virtual unsigned int | getInputDim () const
| returns the number of input neurons
virtual unsigned int | getOutputDim () const
| returns the number of output neurons
virtual void | damp (double damping)
| damps the weights and the biases by multiplying (1-damping)
virtual paramkey | getName () const
| return the name of the object (with version number) Hint: { return "$ID$"; }
virtual paramval | getParam (const paramkey key) const
virtual bool | setParam (const paramkey key, paramval val)
virtual paramlist | getParamList () const
| The list of all parameters with there value as allocated lists.

## Constructor & Destructor Documentation

MultiLayerFFNN | ( | double | eps,
|  | const vector< Layer > & | layers
| ) | `[inline]`

  | Parameters:
  | eps | learning rate
  | layers | Layer description (the input layer is not specified (always linear))
Definition at line 28 of file multilayerffnn.h.

virtual ~MultiLayerFFNN | ( |  | ) | `[inline, virtual]`

| Definition at line 34 of file multilayerffnn.h.

## Member Function Documentation

void damp | ( | double | damping | ) | `[virtual]`

| damps the weights and the biases by multiplying (1-damping) Implements FeedForwardNN. Definition at line 86 of file multilayerffnn.cpp.

virtual unsigned int getInputDim | ( |  | ) | const`[inline, virtual]`

| returns the number of input neurons Implements FeedForwardNN. Definition at line 48 of file multilayerffnn.h.

virtual paramkey getName | ( |  | ) | const`[inline, virtual]`

| return the name of the object (with version number) Hint: { return "$ID$"; } Reimplemented from Configurable. Definition at line 60 of file multilayerffnn.h.

virtual unsigned int getOutputDim | ( |  | ) | const`[inline, virtual]`

| returns the number of output neurons Implements FeedForwardNN. Definition at line 52 of file multilayerffnn.h.

virtual paramval getParam | ( | const paramkey | key | ) | const`[inline, virtual]`

| Definition at line 64 of file multilayerffnn.h.

virtual paramlist getParamList | ( |  | ) | const`[inline, virtual]`

| The list of all parameters with there value as allocated lists. Returns: list of key-value pairs Reimplemented from Configurable. Definition at line 76 of file multilayerffnn.h.

void init | ( | unsigned int | inputDim,
|  | unsigned int | outputDim
| ) | `[virtual]`

| initialisation of the network with the given number of input and output units Implements FeedForwardNN. Definition at line 9 of file multilayerffnn.cpp.

const Matrix learn | ( | const matrix::Matrix & | input,
|  | const matrix::Matrix & | nom_output,
|  | double | learnRateFactor = `1`
| ) | `[virtual]`

| performs learning and returns the network output before learning Implements FeedForwardNN. Definition at line 42 of file multilayerffnn.cpp.

const Matrix process | ( | const matrix::Matrix & | input | ) | const`[virtual]`

| passive processing of the input Implements FeedForwardNN. Definition at line 29 of file multilayerffnn.cpp.

virtual bool setParam | ( | const paramkey | key,
|  | paramval | val
| ) | `[inline, virtual]`

| Definition at line 69 of file multilayerffnn.h.